=== debian/changelog ===
golang-opentelemetry-contrib (0.25.0-1) experimental; urgency=medium

  * Initial packaging (Closes: #1022834).

 -- Thomas Goirand <zigo@debian.org>  Wed, 05 Oct 2022 11:53:20 +0200
