=== debian/control ===
Source: golang-opentelemetry-contrib
Section: devel
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Thomas Goirand <zigo@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-golang,
 golang-any,
 golang-github-aws-aws-sdk-go-dev,
 golang-github-aws-smithy-go-dev,
 golang-github-bradfitz-gomemcache-dev,
 golang-github-datadog-datadog-go-dev,
 golang-github-felixge-fgprof-dev,
 golang-github-felixge-httpsnoop-dev,
 golang-github-gin-gonic-gin-dev,
 golang-github-go-kit-kit-dev,
 golang-github-gocql-gocql-dev,
 golang-github-gorilla-mux-dev,
 golang-github-labstack-echo-dev,
 golang-github-labstack-echo.v3-dev,
 golang-github-openshift-api-dev,
 golang-github-prometheus-client-golang-dev,
 golang-github-shirou-gopsutil-dev,
 golang-github-spf13-viper-dev,
 golang-gopkg-macaron.v1-dev,
 golang-mongodb-mongo-driver-dev,
 golang-opentelemetry-otel-dev (>= 1.10.0),
Standards-Version: 4.6.0
Homepage: https://pkg.go.dev/go.opentelemetry.io/contrib
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-opentelemetry-contrib
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-opentelemetry-contrib.git
XS-Go-Import-Path: go.opentelemetry.io/contrib
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-go

Package: golang-opentelemetry-contrib-dev
Architecture: all
Depends:
 golang-github-aws-aws-sdk-go-dev,
 golang-github-aws-smithy-go-dev,
 golang-github-bradfitz-gomemcache-dev,
 golang-github-datadog-datadog-go-dev,
 golang-github-felixge-fgprof-dev,
 golang-github-felixge-httpsnoop-dev,
 golang-github-gin-gonic-gin-dev,
 golang-github-go-kit-kit-dev,
 golang-github-gocql-gocql-dev,
 golang-github-gorilla-mux-dev,
 golang-github-labstack-echo-dev,
 golang-github-labstack-echo.v3-dev,
 golang-github-openshift-api-dev,
 golang-github-prometheus-client-golang-dev,
 golang-github-shirou-gopsutil-dev,
 golang-github-spf13-viper-dev,
 golang-gopkg-macaron.v1-dev,
 golang-mongodb-mongo-driver-dev,
 golang-opentelemetry-otel-dev (>= 1.10.0),
 ${misc:Depends},
Description: Collection of 3rd-party packages for OpenTelemetry-Go
 OpenTelemetry-Go Contrib is a collection of extensions for the
 opentelemetry project. It provides 3rd parth resource detectors,
 propagators, samplers, and instrumentation as submodules.
 .
 OpenTelemetry-Go Contrib contains common values used across all
 instrumentation, exporter, and detector contributions.
