=== debian/changelog ===
golang-opentelemetry-contrib (0.56.0-5) unstable; urgency=medium

  * Team upload.

  [ Nicolas Peugnet ]
  * Add patch to fix tests with go 1.24. (Closes: #1098564)

  [ Guillem Jover ]
  * Switch to Standards-Version 4.7.2 (no changes needed).
  * Update copyright years.
  * Update debian-branch in debian/gbp.conf.

 -- Guillem Jover <gjover@sipwise.com>  Tue, 04 Mar 2025 14:40:00 +0100

golang-opentelemetry-contrib (0.56.0-4) unstable; urgency=medium

  * Team upload
  * Change Breaks to declare golang-github-prometheus-prometheus-dev
    instead of prometheus to help with testing migration

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 01 Nov 2024 05:43:01 -0400

golang-opentelemetry-contrib (0.56.0-3) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * Add Breaks: prometheus (<< 2.45.6+ds-6)

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 31 Oct 2024 06:20:10 -0400

golang-opentelemetry-contrib (0.56.0-2) experimental; urgency=medium

  * Team upload.
  * Run wrap-and-sort -ast.
  * Switch to Standards-Version 4.7.0 (no changes needed).
  * Place each Makefile variable element on its own line.
  * Update gbp configuration following Go Team new workflow.
  * Use dh-sequence-golang instead of dh-golang and --with=golang.
  * Remove specific tag component from Source field in debian/control.
  * Include propagators/b3 and zpages needed by golang-opentelemetry-collector.
  * Add debian/.gitignore file.

 -- Guillem Jover <gjover@sipwise.com>  Tue, 22 Oct 2024 00:39:43 +0200

golang-opentelemetry-contrib (0.56.0-1) experimental; urgency=medium

  * Team upload
  * Tighten dependencies on otel-dev
  * New upstream version: 0.56.0
  * Refresh patches
  * New dependencies: zapcore, logrus

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 20 Oct 2024 20:33:40 -0400
