=== debian/control ===
--- 
+++ 
@@ -4,33 +4,39 @@
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders:
  Thomas Goirand <zigo@debian.org>,
+Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
- dh-golang,
+ dh-sequence-golang,
  golang-any,
  golang-github-felixge-httpsnoop-dev,
  golang-github-google-go-cmp-dev,
  golang-github-gorilla-mux-dev,
+ golang-github-sirupsen-logrus-dev,
  golang-github-stretchr-testify-dev,
+ golang-go.uber-zap-dev,
  golang-google-grpc-dev,
  golang-google-protobuf-dev,
- golang-opentelemetry-otel-dev (>= 1.10.0),
-Standards-Version: 4.6.0
+ golang-opentelemetry-otel-dev (>= 1.31),
+Testsuite: autopkgtest-pkg-go
+Standards-Version: 4.7.2
 Homepage: https://pkg.go.dev/go.opentelemetry.io/contrib
 Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-opentelemetry-contrib
 Vcs-Git: https://salsa.debian.org/go-team/packages/golang-opentelemetry-contrib.git
 XS-Go-Import-Path: go.opentelemetry.io/contrib
-Rules-Requires-Root: no
-Testsuite: autopkgtest-pkg-go
 
 Package: golang-opentelemetry-contrib-dev
 Architecture: all
 Depends:
  golang-github-felixge-httpsnoop-dev,
+ golang-github-sirupsen-logrus-dev,
+ golang-go.uber-zap-dev,
  golang-google-grpc-dev,
  golang-google-protobuf-dev,
- golang-opentelemetry-otel-dev (>= 1.10.0),
+ golang-opentelemetry-otel-dev (>= 1.31),
  ${misc:Depends},
+Breaks:
+ golang-github-prometheus-prometheus-dev (<< 2.45.6+ds-6)
 Description: Collection of 3rd-party packages for OpenTelemetry-Go
  OpenTelemetry-Go Contrib is a collection of extensions for the
  opentelemetry project. It provides 3rd parth resource detectors,
