=== debian/watch ===
version=4
opts="filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,searchmode=plain" \
    https://api.github.com/repos/open-telemetry/opentelemetry-go-contrib/tags?per_page=100 \
    https://api.github.com/repos/open-telemetry/opentelemetry-go-contrib/tarball/refs/tags/zpages/@ANY_VERSION@
